#####################################################################
#####################################################################
## Versavant Topic Map Application Bus / Subject Addressing Engine ##
## Copyright 2005 Steven R. Newcomb                                ##
##                                                                 ##
## This software is licensed under the Apache License, Version 2.0 ##
## (the "License"); you may not use this file except in compliance ##
## with the License.  Copies of the License are available at       ##
##        http://www.apache.org/licenses/LICENSE-2.0               ##
##                                                                 ##
## Unless required by applicable law or agreed to in writing,      ##
## software distributed under the License is distributed on an "AS ##
## IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either ##
## express or implied.  See the License for the specific language  ##
## governing permissions and limitations under the License.        ##
##                                                                 ##
## Copies of the source code and the license are available at      ##
##        http://www.versavant.org                                 ##
#####################################################################
#####################################################################

######################################################################################
## A simple property class implementation for properties whose values are strings.  ##
######################################################################################

#######################################################
def Add_string_PropToOverheadDict( vsv, propertyInstance, overheadDict):
    valueHash = propertyInstance.hashablePropertyValue = propertyInstance._value
    if overheadDict.has_key( valueHash):
        overheadDict[ valueHash].append( propertyInstance.proxyId)
    else:
        overheadDict[ valueHash] = [ propertyInstance.proxyId]


#######################################################
def Remove_string_PropFromOverheadDict( vsv, propertyInstance, overheadDict):
    valueHash = propertyInstance.hashablePropertyValue
    overheadDict[ valueHash].remove( propertyInstance.proxyId)
    if not len( overheadDict[ valueHash]):
        del overheadDict[ valueHash]  ## be a good citizen and clean up after yourself


#######################################################
def Merge_string_PropertyValues( vsv, value1, value2):
    if value1 == value2:
        return value1
    else:
        return None  ## the merge failed.

#######################################################
def ValuesOf_string_PropertyInstancesAreSignificantlyDifferent( vsv, value1, value2):
    if value1 == value2:
        return False
    else:
        return True  

#######################################################
def ProxiesOfSubjectIdentifiedBy_string_Value( vsv, propertyClass, value):
    if propertyClass.overheadDict.has_key( value):
        return propertyClass.overheadDict[ value]
    else:
        return []  ## empty list -- no match

#######################################################
def MergeProxiesBecause_string_PropertyInstancesSpecifySameSubject( vsv, propertyClass):
    ## Declare this one if and only if your property class is for SIPs
    ## (subject identity properties).
    for hashablePropertyValue in propertyClass.overheadDict:
        if len( propertyClass.overheadDict[ hashablePropertyValue]) > 1:
            vsv.mergeListOfProxies( propertyClass, propertyClass.overheadDict[ hashablePropertyValue])
    
